# yamllint disable
# License: GNU Lesser General Public License v3.0
# source (original): https://find-sec-bugs.github.io/bugs.htm
# yamllint enable
---
rules:
  - id: "kotlin_inject_rule-ELInjection"
    languages:
      - "kotlin"
    message: |
      An expression is built with a dynamic value. The source of the value(s) should be verified to
      avoid that unfiltered values fall into this risky code evaluation.
    metadata:
      category: "security"
      cwe: "CWE-917"
      shortDescription: "Improper neutralization of special elements used in an expression language statement ('Expression Language Injection')"
      owasp:
        - "A1:2017-Injection"
        - "A03:2021-Injection"
      technology:
        - "kotlin"
      security-severity: "MEDIUM"
    severity: "WARNING"

    pattern-either:
      - patterns:
          - metavariable-regex:
              metavariable: "$METHOD"
              regex: "^create(Method|Value)Expression$"
          - metavariable-pattern:
              metavariable: "$EXPR"
              patterns:
                - pattern-not: '"..."'
          - pattern: |
              ($EXP: ExpressionFactory ).$METHOD(($CTX: $X.el.ELContext), $EXPR, ...)
      - patterns:
          - pattern: |
              ($P: $X.el.ELProcessor).$METHOD(...)
          - pattern-not: |
              ($P: $X.el.ELProcessor).$METHOD("...", ...)
          - metavariable-regex:
              metavariable: "$METHOD"
              regex: "^(eval|(get|set)Value)$"
